/*
 * Copyright (C) Eric Wong, 2012
 * License: GPLv3 or later (see COPYING for details)
 */
#include "check.h"

int main(void)
{
	struct mog_queue *q = mog_queue_new();
	struct mog_fd *in = mog_fd_get(STDIN_FILENO);
	struct mog_fd *out = mog_fd_get(STDOUT_FILENO);
	struct mog_fd *err = mog_fd_get(STDERR_FILENO);
	struct mog_fd *took;

	assert(q && in && "not initialized");

	in->queue_state = MOG_QUEUE_STATE_OLD;
	out->queue_state = MOG_QUEUE_STATE_OLD;
	err->queue_state = MOG_QUEUE_STATE_OLD;

	mog_activeq_push(q, in);

	took = mog_activeq_trytake(q);
	assert(in == took && "took what we pushed in");
	took = mog_activeq_trytake(q);
	assert(NULL == took && "empty queue");

	mog_activeq_push(q, in);
	mog_activeq_push(q, out);
	mog_activeq_push(q, err);

	took = mog_activeq_trytake(q);
	assert(in == took && "stdin in-order");

	took = mog_activeq_trytake(q);
	assert(out == took && "stdout in-order");

	took = mog_activeq_trytake(q);
	assert(err == took && "stderr in-order");

	took = mog_activeq_trytake(q);
	assert(NULL == took && "empty queue");

	return 0;
}
